//+------------------------------------------------------------------+
//|               stochastic momentum with divergences, histo and bb |
//|                          mladen / histo and bb added by airquest |
//|                                                                  |
//| Stochastic momentum developed by William Blau                    |
//+------------------------------------------------------------------+
#property copyright "mladen / modified by airquest"
#property link      "mladenfx@gmail.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 15
//+------------------------Histo------------------------------------+
#property indicator_color1  LimeGreen
#property indicator_color2  LimeGreen
#property indicator_color3  DarkOrange
#property indicator_color4  DarkOrange
#property indicator_width1  2
#property indicator_width3  2
//+--------------------------BB-------------------------------------+
#property indicator_color5  Orange
#property indicator_style5  STYLE_SOLID
#property indicator_color6  Orange
#property indicator_style6  STYLE_DOT
#property indicator_color7  LimeGreen
#property indicator_style7  STYLE_DOT
#property indicator_color8  LimeGreen
#property indicator_style8  STYLE_SOLID
#property indicator_color9  DarkGray
#property indicator_style9  STYLE_SOLID
//+------------------------------------------------------------------+
#property indicator_color10    LimeGreen //SMI up
#property indicator_color11    OrangeRed //SMI down
#property indicator_color12    OrangeRed
#property indicator_width10    2
#property indicator_width11    2
#property indicator_width12    2
//+------------------------------------------------------------------+
#property indicator_color13    Goldenrod //Signal line
//+------------------------------------------------------------------+
#property indicator_color14    LimeGreen //Arrow up
#property indicator_color15    OrangeRed //Arrow down
//+------------------------------------------------------------------+
#property indicator_levelcolor DarkSlateGray
//+------------------------------------------------------------------+

extern int    Length                    = 5;
extern int    Smooth1                   = 3;
extern int    Smooth2                   = 5;
extern int    Signal                    = 1;
extern bool   ColorOnSlope              = False;
extern int    Price                     = PRICE_CLOSE;
extern bool   ShowLevels                = False;
//+------------------------------------------------------------------+
extern bool   ShowBollingerBands        = False;
extern int    BBPeriod                  = 20;
extern int    BBMaMethod                = MODE_SMA;
extern double BBDeviation1              = 2.0;
extern double BBDeviation2              = 3.0;
extern bool   Show2ndDev                = False;
//+------------------------------------------------------------------+
extern bool   ShowHistograms           = True;
extern int    HistoColorMode           = 0;
extern string HistoColorModeNote       = "0 = On zero cross; 1 = On bb ma cross;";
//+------------------------------------------------------------------+
extern int    DivergeArrowSize          = 1; 
extern bool   drawDivergences           = False;
extern bool   drawIndicatorTrendLines   = False;
extern bool   drawPriceTrendLines       = False;
extern string drawLinesIdentificator    = "SMIdiverge1";
extern string ___                       = "Divergence Alerts";
extern bool   divergenceAlert           = False;
extern bool   divergenceAlertsMessage   = False;
extern bool   divergenceAlertsSound     = False;
extern bool   divergenceAlertsNotify    = False;
extern bool   divergenceAlertsEmail     = False;
extern string divergenceAlertsSoundName = "alert1.wav";

//+------------------------------------------------------------------+

double bullishDivergence[];
double bearishDivergence[];
double SMIBufferDa[];
double SMIBufferDb[];
double smo[];
double sms[];
double tBuffer[][6];
double colors[];

string indicatorName;
string labelNames;

double pipMultiplier = 1;

//+------------------------------------------------------------------+

double BBUp1[];
double BBUp2[];
double BBDown1[];
double BBDown2[];
double BBMiddle[];

//+------------------------------------------------------------------+

double osc_uu[];
double osc_ud[];
double osc_du[];
double osc_dd[];
double slope[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   IndicatorBuffers(17);

   SetIndexBuffer(0,osc_uu); SetIndexStyle(0,DRAW_HISTOGRAM);  if(!ShowHistograms) SetIndexStyle(0,DRAW_NONE);
   SetIndexBuffer(1,osc_ud); SetIndexStyle(1,DRAW_HISTOGRAM);  if(!ShowHistograms) SetIndexStyle(1,DRAW_NONE);
   SetIndexBuffer(2,osc_dd); SetIndexStyle(2,DRAW_HISTOGRAM);  if(!ShowHistograms) SetIndexStyle(2,DRAW_NONE);
   SetIndexBuffer(3,osc_du); SetIndexStyle(3,DRAW_HISTOGRAM);  if(!ShowHistograms) SetIndexStyle(3,DRAW_NONE);

   SetIndexBuffer(4,BBDown2);   if(!ShowBollingerBands) SetIndexStyle(4,DRAW_NONE);  SetIndexLabel(4,NULL);
   SetIndexBuffer(5,BBDown1);   if(!ShowBollingerBands) SetIndexStyle(5,DRAW_NONE);  SetIndexLabel(5,NULL);
   SetIndexBuffer(6,BBUp1);     if(!ShowBollingerBands) SetIndexStyle(6,DRAW_NONE);  SetIndexLabel(6,NULL);
   SetIndexBuffer(7,BBUp2);     if(!ShowBollingerBands) SetIndexStyle(7,DRAW_NONE);  SetIndexLabel(7,NULL);
   SetIndexBuffer(8,BBMiddle);  if(!ShowBollingerBands) SetIndexStyle(8,DRAW_NONE);  SetIndexLabel(8,NULL);

   SetIndexBuffer(9,smo);  //SetIndexLabel(0,"Stochastic momentum");
   SetIndexBuffer(10,SMIBufferDa);
   SetIndexBuffer(11,SMIBufferDb);
   SetIndexBuffer(12,sms); //SetIndexLabel(1,"Stochastic momentum signal");
   SetIndexBuffer(13,bullishDivergence);  SetIndexStyle(13,DRAW_ARROW,0,DivergeArrowSize);  SetIndexArrow(13,233);
   SetIndexBuffer(14,bearishDivergence);  SetIndexStyle(14,DRAW_ARROW,0,DivergeArrowSize);  SetIndexArrow(14,234);  
   SetIndexBuffer(15,colors);
   SetIndexBuffer(16,slope);

   if(ShowLevels)
   {
      SetLevelValue(0,0);
      SetLevelValue(1,15);
      SetLevelValue(2,-15);
      SetLevelValue(3,40);
      SetLevelValue(4,-40);
      SetLevelStyle(STYLE_DOT,0);
   }

   Length  = MathMax(Length ,1);
   Smooth1 = MathMax(Smooth1,1);
   Smooth2 = MathMax(Smooth2,1);
       
   labelNames    = "SMI_DivergenceLine "+drawLinesIdentificator+":";
   indicatorName = " SMI ("+Length+","+Smooth1+","+Smooth2+","+Price+")";
   IndicatorShortName("SMI ("+Length+","+Smooth1+","+Smooth2+","+Price+")");

return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int deinit()
{  
   int length=StringLen(labelNames);
   for(int i=ObjectsTotal()-1; i>=0; i--)
   {
      string name = ObjectName(i);
      if(StringSubstr(name,0,length) == labelNames)  ObjectDelete(name);   
   }

return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

#define ema10 0
#define ema11 1
#define ema12 2
#define ema20 3
#define ema21 4
#define ema22 5

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(tBuffer,0) != Bars) ArrayResize(tBuffer,Bars);
         if (colors[limit]==-1) CleanPoint(limit,SMIBufferDa,SMIBufferDb);
         if (Digits==3 || Digits==5) 
               pipMultiplier = 10;
         else  pipMultiplier = 1; 
   
         double alpha1 = 2.0 /(1.0+Smooth1);
         double alpha2 = 2.0 /(1.0+Smooth2);
         double alphas = 2.0 /(1.0+Signal);

   for(i=limit,r=Bars-i-1; i>=0; i--,r++)
   {
      double hh = High[iHighest(NULL,0,MODE_HIGH,Length,i)];
      double ll =  Low[ iLowest(NULL,0,MODE_LOW ,Length,i)];
      double pr = iMA(NULL,0,1,0,MODE_SMA,Price,i);

         tBuffer[r][ema10] = pr - 0.5*(hh+ll);
         tBuffer[r][ema20] =           hh-ll;
         if (i>=Bars-3)
         {
            tBuffer[r][ema11] = tBuffer[r][ema10];
            tBuffer[r][ema12] = tBuffer[r][ema10];
            tBuffer[r][ema21] = tBuffer[r][ema20];
            tBuffer[r][ema22] = tBuffer[r][ema20];
            continue;
         }
      
      tBuffer[r][ema11] = tBuffer[r-1][ema11] + alpha1*(tBuffer[r][ema10]-tBuffer[r-1][ema11]);
      tBuffer[r][ema12] = tBuffer[r-1][ema12] + alpha2*(tBuffer[r][ema11]-tBuffer[r-1][ema12]);
      tBuffer[r][ema21] = tBuffer[r-1][ema21] + alpha1*(tBuffer[r][ema20]-tBuffer[r-1][ema21]);
      tBuffer[r][ema22] = tBuffer[r-1][ema22] + alpha2*(tBuffer[r][ema21]-tBuffer[r-1][ema22]);

         smo[i] = 100.00 * tBuffer[r][ema12] / (0.5 * tBuffer[r][ema22]);

         SMIBufferDa[i] = EMPTY_VALUE;
         SMIBufferDb[i] = EMPTY_VALUE;
         colors[i] = colors[i+1];
         if (ColorOnSlope)
            {
              if (smo[i]>smo[i+1]) colors[i]= 1;
              if (smo[i]<smo[i+1]) colors[i]=-1;
            }
             else
            {
             if (smo[i]>sms[i+1]) colors[i]= 1;
             if (smo[i]<sms[i+1]) colors[i]=-1;
            }
            if (colors[i] == -1) PlotPoint(i,SMIBufferDa,SMIBufferDb,smo);  

         if (Signal>1)
            sms[i] = sms[i+1]+alphas*(smo[i]-sms[i+1]);

            if (drawDivergences)
            {
              CatchBullishDivergence(i);
              CatchBearishDivergence(i);
            }
   }
//+------------------------------------------------------------------
      if(ShowBollingerBands)
      {
         for(i=0; i<limit; i++)
         {
             double deviation = iStdDevOnArray(smo,0,BBPeriod,0,BBMaMethod,i);
             BBMiddle[i] = iMAOnArray(smo,0,BBPeriod,0,BBMaMethod,i);
             if(Show2ndDev)
             {
                BBUp1[i]     = BBMiddle[i]+(BBDeviation1*deviation);
                BBUp2[i]     = BBMiddle[i]+(BBDeviation2*deviation);
                BBDown1[i]   = BBMiddle[i]-(BBDeviation1*deviation);
                BBDown2[i]   = BBMiddle[i]-(BBDeviation2*deviation);
             }
             else
             {
                BBUp1[i]     = EMPTY_VALUE;
                BBUp2[i]     = BBMiddle[i]+(BBDeviation1*deviation);
                BBDown1[i]   = EMPTY_VALUE;
                BBDown2[i]   = BBMiddle[i]-(BBDeviation1*deviation);
             }
         }
      }
//+------------------------------------------------------------------
      for(i = limit; i>=0; i--)
      {
            slope[i]  = slope[i+1];
            osc_uu[i] = EMPTY_VALUE;
            osc_ud[i] = EMPTY_VALUE;
            osc_dd[i] = EMPTY_VALUE;
            osc_du[i] = EMPTY_VALUE;
               if (smo[i]>smo[i+1]) slope[i] =  1;
               if (smo[i]<smo[i+1]) slope[i] = -1;
               if(HistoColorMode == 0)
               {
                  if (smo[i] > 0)
                     if (slope[i] == 1)
                           osc_uu[i] = smo[i];
                     else  osc_ud[i] = smo[i];  
                  if (smo[i] < 0)
                     if (slope[i] == 1)
                           osc_du[i] = smo[i];
                     else  osc_dd[i] = smo[i];  
               }
               if(HistoColorMode == 1)
               {
                  if (smo[i] > BBMiddle[i])
                     if (slope[i] == 1)
                           osc_uu[i] = smo[i];
                     else  osc_ud[i] = smo[i];  
                  if (smo[i] < BBMiddle[i])
                     if (slope[i] == 1)
                           osc_du[i] = smo[i];
                     else  osc_dd[i] = smo[i];  
               }
      }
//+------------------------------------------------------------------
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void CatchBullishDivergence(int shift)
{
   shift++;
         bullishDivergence[shift] = EMPTY_VALUE;
            ObjectDelete(labelNames+"l"+DoubleToStr(Time[shift],0));
            ObjectDelete(labelNames+"l"+"os" + DoubleToStr(Time[shift],0));            
   if(!IsIndicatorLow(shift)) return;
      
   int currentLow = shift;
   int lastLow    = GetIndicatorLastLow(shift+1);
    
   if(smo[currentLow] > smo[lastLow] && Low[currentLow] < Low[lastLow])
   {
      bullishDivergence[currentLow] = smo[currentLow] - Point*pipMultiplier;
      if(drawPriceTrendLines == true)
                 DrawPriceTrendLine("l",Time[currentLow],Time[lastLow],Low[currentLow],Low[lastLow],Green,STYLE_SOLID);
      if(drawIndicatorTrendLines == true)
                 DrawIndicatorTrendLine("l",Time[currentLow],Time[lastLow],smo[currentLow],smo[lastLow],Green,STYLE_SOLID);
      if(divergenceAlert == true)
                 DisplayAlert("Classical bullish divergence",currentLow);  
                        
   }
        
   if(smo[currentLow] < smo[lastLow] && Low[currentLow] > Low[lastLow])
   {
      bullishDivergence[currentLow] = smo[currentLow] - Point*pipMultiplier;
      if(drawPriceTrendLines == true)
                 DrawPriceTrendLine("l",Time[currentLow],Time[lastLow],Low[currentLow],Low[lastLow], Green, STYLE_DOT);
      if(drawIndicatorTrendLines == true)                            
                 DrawIndicatorTrendLine("l",Time[currentLow],Time[lastLow],smo[currentLow],smo[lastLow], Green, STYLE_DOT);
      if(divergenceAlert == true)
                 DisplayAlert("Reverse bullish divergence",currentLow); 
   }
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void CatchBearishDivergence(int shift)
{
   shift++; 
         bearishDivergence[shift] = EMPTY_VALUE;
            ObjectDelete(labelNames+"h"+DoubleToStr(Time[shift],0));
            ObjectDelete(labelNames+"h"+"os" + DoubleToStr(Time[shift],0));            
   if(IsIndicatorPeak(shift) == false) return;
   int currentPeak = shift;
   int lastPeak = GetIndicatorLastPeak(shift+1);
      
   if(smo[currentPeak] < smo[lastPeak] && High[currentPeak]>High[lastPeak])
   {
       bearishDivergence[currentPeak] = smo[currentPeak] + Point*pipMultiplier;
       if(drawPriceTrendLines == true)
               DrawPriceTrendLine("h",Time[currentPeak],Time[lastPeak],High[currentPeak],High[lastPeak],Red,STYLE_SOLID);
       if(drawIndicatorTrendLines == true)
               DrawIndicatorTrendLine("h",Time[currentPeak],Time[lastPeak],smo[currentPeak],smo[lastPeak],Red,STYLE_SOLID);
       if(divergenceAlert == true)
               DisplayAlert("Classical bearish divergence",currentPeak); 
                        
   }

   if(smo[currentPeak] > smo[lastPeak] && High[currentPeak] < High[lastPeak])
   {
      bearishDivergence[currentPeak] = smo[currentPeak] + Point*pipMultiplier;
      if (drawPriceTrendLines == true)
               DrawPriceTrendLine("h",Time[currentPeak],Time[lastPeak],High[currentPeak],High[lastPeak],Red, STYLE_DOT);
      if (drawIndicatorTrendLines == true)
               DrawIndicatorTrendLine("h",Time[currentPeak],Time[lastPeak],smo[currentPeak],smo[lastPeak], Red, STYLE_DOT);
      if(divergenceAlert == true)
               DisplayAlert("Reverse bearish divergence",currentPeak);
                         
   }   
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

bool IsIndicatorPeak(int shift)
{
   if(smo[shift] >= smo[shift+1] && smo[shift] > smo[shift+2] && smo[shift] > smo[shift-1])
       return(true);
   else 
       return(false);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

bool IsIndicatorLow(int shift)
{
   if(smo[shift] <= smo[shift+1] && smo[shift] < smo[shift+2] && smo[shift] < smo[shift-1])
       return(true);
   else 
       return(false);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int GetIndicatorLastPeak(int shift)
{
    for(int i = shift+5; i < Bars; i++)
    {
       if(smo[i] >= smo[i+1] && smo[i] > smo[i+2] && smo[i] >= smo[i-1] && smo[i] > smo[i-2])
         return(i);
    }
return(-1);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int GetIndicatorLastLow(int shift)
{
    for (int i = shift+5; i < Bars; i++)
    {
       if (smo[i] <= smo[i+1] && smo[i] < smo[i+2] && smo[i] <= smo[i-1] && smo[i] < smo[i-2])
         return(i);
    }
return(-1);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void DisplayAlert(string doWhat, int shift)
{
    string dmessage;
    static datetime lastAlertTime;
    if(shift <= 2 && Time[0] != lastAlertTime)
    {
      dmessage =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," SMI ",doWhat);
          if (divergenceAlertsMessage) Alert(dmessage);
          if (divergenceAlertsNotify)  SendNotification(dmessage);
          if (divergenceAlertsEmail)   SendMail(StringConcatenate(Symbol()," SMI "),dmessage);
          if (divergenceAlertsSound)   PlaySound(divergenceAlertsSoundName); 
          lastAlertTime = Time[0];
    }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void DrawPriceTrendLine(string first,datetime t1, datetime t2, double p1, double p2, color lineColor, double style)
{
    string label = labelNames+first+"os"+DoubleToStr(t1,0);
      ObjectDelete(label);
      ObjectCreate(label, OBJ_TREND, 0, t1, p1, t2, p2, 0, 0);
         ObjectSet(label, OBJPROP_RAY, 0);
         ObjectSet(label, OBJPROP_COLOR, lineColor);
         ObjectSet(label, OBJPROP_STYLE, style);
}

void DrawIndicatorTrendLine(string first,datetime t1, datetime t2, double p1, double p2, color lineColor, double style)
{
    int indicatorWindow = WindowFind(indicatorName);
    if (indicatorWindow < 0) return;
    
    string label = labelNames+first+DoubleToStr(t1,0);
      ObjectDelete(label);
      ObjectCreate(label, OBJ_TREND, indicatorWindow, t1, p1, t2, p2, 0, 0);
         ObjectSet(label, OBJPROP_RAY, 0);
         ObjectSet(label, OBJPROP_COLOR, lineColor);
         ObjectSet(label, OBJPROP_STYLE, style);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE)
            {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else
            {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}